---CENTRAL-SERVER-SYSTEM

var Think,WaitC,UseC,Stopped,WaitD,UseD,IdleD,BusyD,IdleC,BusyC,Pbusy,Noint,Int: discrete;

automaton p
synclabs : ;

initially ss & True;

loc ss : while 
	   Think >= 0 &
	   WaitC >= 0 &
	   UseC >= 0 &
	   Stopped >= 0 &
	   WaitD >= 0 &
	   UseD >= 0 &
	   IdleD >= 0 &
	   BusyD >= 0 &
	   IdleC >= 0 &
	   BusyC >= 0 &
	   Pbusy >= 0 &
	   Noint >= 0 &
	   Int >= 0 &
---invariants
	   Pbusy + IdleC + BusyC = 1 &
	   IdleD + BusyD = 1 &
	   Noint + Int = 1
	   wait { }

--- REQ
	when
	  Think>=1
	do {
	  Think'=Think-1,
	  WaitC'=WaitC+1
	} goto ss;

--- USE_C
	when
	  WaitC>=1 & IdleC>=1
	do {
	  WaitC'=WaitC-1,
	  UseC'=UseC+1,
	  IdleC'=IdleC-1,
	  BusyC'=BusyC+1
	} goto ss;

--- RELEASE_C
	when
	  UseC>=1 & BusyC>=1
	do {
	  BusyC'=BusyC-1,
	  IdleC'=IdleC+1,
	  UseC'=UseC-1,
	  Think'=Think+1
	} goto ss;

	when 
	  UseC>=1 & BusyC>=1
	do {
	  BusyC'=BusyC-1,
	  IdleC'=IdleC+1,
	  UseC'=UseC-1,
	  WaitD'=WaitD+1
	} goto ss;

--- USE-D
	when
	  WaitD>=1 & IdleD>=1
	do {
	  WaitD'=WaitD-1,
	  UseD'=UseD+1,
	  IdleD'=IdleD-1,
	  BusyD'=BusyD+1
	} goto ss;

--- RELEASE_D
	when
	  UseD>=1 & BusyD>=1
	do {
	  BusyD'=BusyD-1,
	  IdleD'=IdleD+1,
	  UseD'=UseD-1,
	  WaitC'=WaitC+1
	} goto ss;

--- STOP
	when
	  Noint>=1
	do {
	  Noint'=Noint-1,
	  Int'=Int+1,
	  Stopped'=UseC+Stopped,
	  UseC'=0,
	  Pbusy'=Pbusy+IdleC,
	  IdleC'=0
	} goto ss;

---RETURN
	when
	  Int>=1
	do {
	  UseC'=Stopped+UseC,
	  Stopped'=0,
	  Noint'=Noint+1,
	  Int'=Int-1,
	  IdleC'=IdleC+Pbusy,
	  Pbusy'=0
	} goto ss;

end

var
  Init_reg, Final_reg1,Final_reg2,Final_reg3,Final_reg4, Reached : region;

Init_reg := loc[p] = ss & Think >= 1 & IdleC = 1 & IdleD = 1 & Noint = 1 & WaitC = 0 & UseD = 0 & Stopped = 0 & UseC = 0 & WaitD = 0 & Pbusy = 0 & BusyC = 0 & BusyD = 0 & Int = 0;

Final_reg1:= UseC >= 2; 
Final_reg2:= UseC >= 5;
Final_reg3:= UseC >= 10;
Final_reg4:= UseC >= 15;

Reached:= reach backward from Final_reg1 endreach;

if empty(Reached & Init_reg) then
	prints "SAFE";
else
	prints "ERROR";
endif;
